Package org.apache.sysds.runtime.matrix.data

# Class LibMatrixDNNPooling

java.lang.Object
org.apache.sysds.runtime.matrix.data.LibMatrixDNNPooling

public class LibMatrixDNNPooling extends Object
This class contains the set of operators used for performing pooling

## Constructor Summary

Constructors
Constructor
Description
`LibMatrixDNNPooling()`

## Method Summary

Modifier and Type
Method
Description
`static ArrayList<Callable<Long>>`
`getPoolingBackwardWorkers(DnnParameters params, boolean performReluBackward, LibMatrixDNN.PoolingType poolType)`
Factory method that returns list of callable tasks for performing maxpooling backward operation
`static ArrayList<Callable<Long>>`
`getPoolingWorkers(DnnParameters params, LibMatrixDNN.PoolingType poolType)`
Factory method that returns list of callable tasks for performing pooling operation
`static void`
`poolingDenseStride1Pad0(LibMatrixDNN.PoolingType pType, double minVal, double pFact, double[] in, double[] out, int rl, int ru, int ii, int oi, int C, int P, int Q, int R, int S, int H, int W)`

### Methods inherited from class java.lang.Object

`equals, getClass, hashCode, notify, notifyAll, toString, wait, wait, wait`

## Constructor Details

### LibMatrixDNNPooling

public LibMatrixDNNPooling()

## Method Details

### getPoolingWorkers

public static ArrayList<Callable<Long>> getPoolingWorkers(DnnParameters params, LibMatrixDNN.PoolingType poolType)
Factory method that returns list of callable tasks for performing pooling operation

Parameters:
  `params` - convolution parameters
  `poolType` - type of pooling
Returns:
  list of callable tasks for performing pooling operation

### getPoolingBackwardWorkers

public static ArrayList<Callable<Long>> getPoolingBackwardWorkers(DnnParameters params, boolean performReluBackward, LibMatrixDNN.PoolingType poolType)
Factory method that returns list of callable tasks for performing maxpooling backward operation

Parameters:
  `params` - convolution parameters
  `performReluBackward` - whether to perform ReLU backward
  `poolType` - type of pooling operation to perform
Returns:
  list of callable tasks for performing maxpooling backward operation

### poolingDenseStride1Pad0

public static void poolingDenseStride1Pad0(LibMatrixDNN.PoolingType pType, double minVal, double pFact, double[] in, double[] out, int rl, int ru, int ii, int oi, int C, int P, int Q, int R, int S, int H, int W)